import java.awt.*;
import java.awt.event.*;
import java.applet.*;


public class PiApplet extends Applet {
  String orig_process;
  boolean orig_debug;
  BorderLayout PanelTopLayout = new BorderLayout();
  Panel PanelTop = new Panel();
  Button BtnGo = new Button();
  TextArea EdText = new TextArea();
  TextField EdCommand = new TextField();
  BorderLayout borderLayout1 = new BorderLayout();

  boolean hasstarted=false;
  Model.State state=null;
  java.util.Random rnd=new java.util.Random();

  public String getAppletInfo() {return "pi app info";}
  public String[][] getParameterInfo() {
    String[][] pinfo = {{"process", "String", "A pi-process to run"}, {"debug","String","Set to TRUE for extra information"}};
    return pinfo;
  }

  public PiApplet() {}
  public void start() { }
  public void stop() { }
  public void destroy() { }

  public void init() {
    orig_process = getParameter("process");
    if (orig_process==null) orig_process="u<x> | u(y).y<>";
    String sdebug=getParameter("debug"); if (sdebug==null) sdebug="";
    orig_debug = (sdebug.equals("1") || sdebug.equalsIgnoreCase("true") || sdebug.equalsIgnoreCase("y") || sdebug.equalsIgnoreCase("yes"));
    //
    this.setLayout(PanelTopLayout);
    BtnGo.setLabel("Step");
    BtnGo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BtnGo_actionPerformed(e);
      }
    });
    EdCommand.addTextListener(new java.awt.event.TextListener() {
      public void textValueChanged(TextEvent e) {
        EdCommand_textValueChanged(e);
      }
    });
    EdText.setBackground(SystemColor.window);
    EdCommand.setBackground(SystemColor.window);
    EdCommand.setText(orig_process);
    PanelTop.setLayout(borderLayout1);
    this.add(EdText, BorderLayout.CENTER);
    this.add(PanelTop, BorderLayout.NORTH);
    PanelTop.add(EdCommand, BorderLayout.CENTER);
    PanelTop.add(BtnGo, BorderLayout.EAST);
  }


  void EdCommand_textValueChanged(TextEvent e)
  { hasstarted=false;
  }
  void BtnGo_actionPerformed(ActionEvent ev)
  { try
    { if (!hasstarted)
      { EdText.setText("");
        String s=EdCommand.getText();
        // First, we use a "text model" with the expression, and parse it
        // 'state' is our global object representing the current state
        Model.State text = new TextModel.State(s);
        state = text.Play(new FmModel.Operators());
        // Now let's print it out
        text = state.Play(new TextModel.Operators());
        //
        //
        s=text.toString(); EdText.append(s+"\n");
        if (orig_debug) EdText.append(state.toString()+"\n");
        hasstarted=true;
      }
      else
      { java.util.Vector seqs=state.EnumEqSteps();
        java.util.Vector sexs=state.EnumExSteps();
        if (seqs.size()==0 && sexs.size()==0)
        { EdText.append("   [no further steps]\n");
          return;
        }
        Object step=null; int istep=0; String symb="";
        int r=rnd.nextInt(); if (r<0) r=-r; r=r % (seqs.size()*2+sexs.size()); 
        if (r<seqs.size()*2) {istep=r/2; step=seqs.elementAt(r/2); symb="==";}
        else {istep=r-seqs.size()*2; step=sexs.elementAt(r-seqs.size()*2); symb="->";}
        if (orig_debug)
        { for (int i=0; i<seqs.size(); i++)
          { String app=" "; if (i==istep) app="*";
            EdText.append("  "+app+"["+Integer.toString(i)+": "+seqs.elementAt(i).toString()+"]\n");
          }
          for (int i=0; i<sexs.size(); i++)
          { int si=i+seqs.size();
            String app=" "; if (si==istep) app="*";
            EdText.append("  "+app+"["+Integer.toString(si)+": "+sexs.elementAt(i).toString()+"]\n");
          }
        }
        try
        { state.Step(step);
          Model.State text = state.Play(new TextModel.Operators());
          String s=text.toString(); EdText.append(symb+" "+s+"\n");
          if (orig_debug) EdText.append(state.toString()+"\n");
        }
        catch (Exception e) {EdText.append(e.toString()+"\n");}
      }
    }
    catch (Exception e) {EdText.append(e.toString()+"\n");}
  }
}
