/* Generated By:JavaCC: Do not edit this line. AutoGram.java */
// This is a grammar, to be compiled with JavaCC.
// It translates from a text string into the pi calculus. The
// pi calculus is represented as an abstract model, solely through
// its operators (Model.Operators ops). That means that when we
// parse the text string "u<x> | u(y)" we will return the
// value ops.Par(ops.Send("u","x"), ops.Rcv("u","y")).
//
// As for the grammar itself:
//  P ::= Loose
//
//  Loose ::= Middle | Middle | ...
//    (A 'loose' is a collection of terms in parallel. It's called 'loose'
//     because parallel composition | binds least tightly.)
//
//  Middle ::= Tight + Tight + ...
//    (Summation binds a bit more tightly. So, "A+B|C" is really (A+B)|C )
//
//  Tight ::= (Loose)
//            (x..)P
//            !Tight
//            0 or Nil
//            x=y
//            Xmit
//    (Actually, here we have an issue. When you first read the ( symbol,
//     you don't know if it will start a restriction or just a parenthetical grouping.
//     We need to look ahead a little. If it is a parenthetical grouping, then
//     the Loose inside must start with (, !, 0, nil, x=, x!, x?, x< or x(.
//     So if we find ( follows by one of those, then we know it's a loose.
//     Any other ( we find must necessarily be a restriction. Yuck! 
//     NB. I disallowed vector fusions x,y,z=u,v,w from the grammar
//     because it would take an unbounded lookahead to distinguish
//     between (x,y,z)P and (x,y,z=u,v,w).
//     Another issue is that when we read 0, it might either be a
//     nil or it might be part of a fusion 0=x, so we have to lookahead
//     for the equals sign. These all feel like horrible hacks! But I'm
//     not good enough with grammars to find a better way.)
//
// Xmit ::= u!dats [.Tight]
//          u?dats [.Tight]
//          u<dats> [.Tight]
//          u(dats) [.Tight]
//          u!(dats) [.Tight]


package TextModel;
public class AutoGram implements AutoGramConstants { static Model.Operators ops=null;
  public static void SetModel(Model.Operators o) {ops=o;}

  // The following family of MakeXxx functions are called by the parser,
  // when it has recognised something. They all call the appropriate
  // function in 'ops'.

  static XmitumData MakeXmitum(boolean issend,Purename chan,boolean isbound,Values dat)
  { XmitumData xd=new XmitumData();
    xd.issend=issend; xd.chan=chan;
    xd.isbound=isbound; xd.dat=dat;
    return xd;
  }
  static Model.State MakeXmit(XmitumData xd,Model.State e) throws ParseException
  { try
    { if (e==null) e=ops.Nil();
      String[] dat = new String[xd.dat.size()];
      for (int i=0; i<xd.dat.size(); i++) dat[i]=xd.dat.valueAt(i).toString();
      if (xd.issend) return ops.Snd(xd.chan.n, dat, xd.isbound, e);
      else return ops.Rcv(xd.chan.n, dat, xd.isbound, e);
    } catch (Exception ex) {throw new ParseException(ex.toString());}
  }
  static Model.State MakeRes(Values nms,Model.State e) throws ParseException
  { try
    { if (nms==null || nms.size()==0) return e;
      String[] bns=new String[nms.size()]; for (int i=0; i<nms.size(); i++) bns[i]=nms.valueAt(i).toString();
      return ops.Res(bns,e);
    } catch (Exception ex) {throw new ParseException(ex.toString());}
  }
  static Model.State MakeRep(Model.State e) throws ParseException
  { try
    { return ops.Rep(e);
    } catch (Exception ex) {throw new ParseException(ex.toString());}
  }
  static Model.State MakeFus(Value n1,Value n2) throws ParseException
  { try
    { Model.State s=ops.Fus(n1.toString(),n2.toString());
      return s;
    } catch (Exception ex) {throw new ParseException(ex.toString());}
  }
  static Model.State MakePar(java.util.Vector es) throws ParseException
  { try
    { if (es.size()==0) return ops.Nil();
      Model.State s=(Model.State)es.elementAt(0);
      for (int i=1; i<es.size(); i++) {Model.State s2=(Model.State)es.elementAt(i); s=ops.Par(s,s2);}
      return s;
    } catch (Exception ex) {throw new ParseException(ex.toString());}
  }
  static Model.State MakeSum(java.util.Vector es) throws ParseException
  { try
    { if (es.size()==0) return ops.Nil();
      Model.State s=(Model.State)es.elementAt(0);
      for (int i=1; i<es.size(); i++) {Model.State s2=(Model.State)es.elementAt(i); s=ops.Par(s,s2);}
      return s;
    } catch (Exception ex) {throw new ParseException(ex.toString());}
  }
  static Model.State MakeNil() throws ParseException
  { try
    { return ops.Nil();
    } catch (Exception ex) {throw new ParseException(ex.toString());}
  }

  static final public Purename Purename() throws ParseException {
  String s;
    jj_consume_token(ID);
          Purename n=new Purename(); n.n=token.image; {if (true) return n;}
    throw new Error("Missing return statement in function");
  }

  static final public Values Purenames() throws ParseException {
  Values vs=new Values(); Value v;
    if (jj_2_1(2)) {
      v = Purename();
                               vs.addElement(v);
      label_1:
      while (true) {
        jj_consume_token(14);
        v = Purename();
                                                                     vs.addElement(v);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 14:
          ;
          break;
        default:
          jj_la1[0] = jj_gen;
          break label_1;
        }
      }
                                                                                           {if (true) return vs;}
    } else {
      label_2:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ID:
          ;
          break;
        default:
          jj_la1[1] = jj_gen;
          break label_2;
        }
        v = Purename();
                   vs.addElement(v);
      }
                                         {if (true) return vs;}
    }
    throw new Error("Missing return statement in function");
  }

  static final public Value Value() throws ParseException {
  String s;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ID:
      jj_consume_token(ID);
          Purename n=new Purename(); n.n=token.image; {if (true) return n;}
      break;
    case NIL0:
      jj_consume_token(NIL0);
            NumericConstant zl=new NumericConstant(); zl.n=0; {if (true) return zl;}
      break;
    case INTEGER:
      jj_consume_token(INTEGER);
               NumericConstant nl=new NumericConstant(); nl.n=Integer.parseInt(token.image); {if (true) return nl;}
      break;
    case STRING:
      jj_consume_token(STRING);
              StringConstant sl=new StringConstant(); sl.s=token.image; {if (true) return sl;}
      break;
    case TRUE:
      jj_consume_token(TRUE);
            BooleanConstant bl=new BooleanConstant(); bl.b=true; {if (true) return bl;}
      break;
    case FALSE:
      jj_consume_token(FALSE);
             BooleanConstant bl2=new BooleanConstant(); bl2.b=false; {if (true) return bl2;}
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  static final public Values Values() throws ParseException {
  Values vs=new Values(); Value v;
    if (jj_2_2(2)) {
      v = Value();
                            vs.addElement(v);
      label_3:
      while (true) {
        jj_consume_token(14);
        v = Value();
                                                               vs.addElement(v);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 14:
          ;
          break;
        default:
          jj_la1[3] = jj_gen;
          break label_3;
        }
      }
                                                                                     {if (true) return vs;}
    } else {
      label_4:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case TRUE:
        case FALSE:
        case NIL0:
        case INTEGER:
        case STRING:
        case ID:
          ;
          break;
        default:
          jj_la1[4] = jj_gen;
          break label_4;
        }
        v = Value();
                vs.addElement(v);
      }
                                      {if (true) return vs;}
    }
    throw new Error("Missing return statement in function");
  }

  static final public Model.State Nil() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NIL:
      jj_consume_token(NIL);
           {if (true) return MakeNil();}
      break;
    case NIL0:
      jj_consume_token(NIL0);
            {if (true) return MakeNil();}
      break;
    default:
      jj_la1[5] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  static final public XmitumData Xmitum() throws ParseException {
  Purename chan; Values dat=null; boolean issend; boolean isbound;
    if (jj_2_3(2)) {
      chan = Purename();
      jj_consume_token(15);
      dat = Purenames();
      jj_consume_token(16);
                                                          issend=false; isbound=true; {if (true) return MakeXmitum(issend,chan,isbound,dat);}
    } else if (jj_2_4(2)) {
      chan = Purename();
      jj_consume_token(17);
      dat = Values();
      jj_consume_token(18);
                                                       issend=true; isbound=false; {if (true) return MakeXmitum(issend,chan,isbound,dat);}
    } else if (jj_2_5(2)) {
      chan = Purename();
      jj_consume_token(19);
      dat = Values();
                                                   issend=false; isbound=false; {if (true) return MakeXmitum(issend,chan,isbound,dat);}
    } else if (jj_2_6(3)) {
      chan = Purename();
      jj_consume_token(20);
      dat = Values();
      jj_consume_token(16);
                                                        issend=true; isbound=true; {if (true) return MakeXmitum(issend,chan,isbound,dat);}
    } else if (jj_2_7(2)) {
      chan = Purename();
      jj_consume_token(21);
      dat = Values();
                                                   issend=true; isbound=false; {if (true) return MakeXmitum(issend,chan,isbound,dat);}
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  static final public Model.State Xmit() throws ParseException {
  XmitumData xe; Model.State p=null; Purename chan;
    if (jj_2_8(2)) {
      chan = Purename();
      jj_consume_token(22);
      p = Tight();
                                                xe=MakeXmitum(true,chan,false,null); {if (true) return MakeXmit(xe,p);}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ID:
        xe = Xmitum();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 22:
          jj_consume_token(22);
          p = Tight();
          break;
        default:
          jj_la1[6] = jj_gen;
          ;
        }
                                  {if (true) return MakeXmit(xe,p);}
        break;
      default:
        jj_la1[7] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

  static final public Model.State Res() throws ParseException {
  Values nms; Model.State p;
    jj_consume_token(15);
    nms = Purenames();
    jj_consume_token(16);
    p = Tight();
                                     {if (true) return MakeRes(nms,p);}
    throw new Error("Missing return statement in function");
  }

  static final public Model.State Rep() throws ParseException {
  Model.State p;
    jj_consume_token(21);
    p = Tight();
                 {if (true) return MakeRep(p);}
    throw new Error("Missing return statement in function");
  }

  static final public Model.State Fusion() throws ParseException {
  Value n1,n2;
    n1 = Value();
    jj_consume_token(23);
    n2 = Value();
                             {if (true) return MakeFus(n1,n2);}
    throw new Error("Missing return statement in function");
  }

  static final public Model.State Tight() throws ParseException {
  Model.State e;
    if (jj_2_9(2147483647)) {
      jj_consume_token(15);
      e = Loose();
      jj_consume_token(16);
                                                     {if (true) return e;}
    } else if (jj_2_10(2147483647)) {
      jj_consume_token(15);
      e = Loose();
      jj_consume_token(16);
                                                     {if (true) return e;}
    } else if (jj_2_11(2147483647)) {
      jj_consume_token(15);
      e = Loose();
      jj_consume_token(16);
                                                     {if (true) return e;}
    } else if (jj_2_12(2147483647)) {
      jj_consume_token(15);
      e = Loose();
      jj_consume_token(16);
                                                     {if (true) return e;}
    } else if (jj_2_13(2147483647)) {
      jj_consume_token(15);
      e = Loose();
      jj_consume_token(16);
                                                  {if (true) return e;}
    } else if (jj_2_14(2147483647)) {
      jj_consume_token(15);
      e = Loose();
      jj_consume_token(16);
                                          {if (true) return e;}
    } else if (jj_2_15(2147483647)) {
      jj_consume_token(15);
      e = Loose();
      jj_consume_token(16);
                                          {if (true) return e;}
    } else if (jj_2_16(2147483647)) {
      jj_consume_token(15);
      e = Loose();
      jj_consume_token(16);
                                            {if (true) return e;}
    } else if (jj_2_17(2147483647)) {
      e = Res();
                            {if (true) return e;}
    } else if (jj_2_18(2147483647)) {
      e = Fusion();
                                       {if (true) return e;}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NIL:
      case NIL0:
        e = Nil();
             {if (true) return e;}
        break;
      case 21:
        e = Rep();
             {if (true) return e;}
        break;
      case ID:
        e = Xmit();
              {if (true) return e;}
        break;
      default:
        jj_la1[8] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

  static final public Model.State Middle() throws ParseException {
  java.util.Vector es=new java.util.Vector(); Model.State e;
    e = Tight();
             es.addElement(e);
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 24:
        ;
        break;
      default:
        jj_la1[9] = jj_gen;
        break label_5;
      }
      jj_consume_token(24);
      e = Tight();
                                                es.addElement(e);
    }
    if (es.size()==1) {if (true) return (Model.State)es.elementAt(0);}
    {if (true) return MakeSum(es);}
    throw new Error("Missing return statement in function");
  }

  static final public Model.State Loose() throws ParseException {
  java.util.Vector es=new java.util.Vector(); Model.State e;
    e = Tight();
             es.addElement(e);
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 25:
        ;
        break;
      default:
        jj_la1[10] = jj_gen;
        break label_6;
      }
      jj_consume_token(25);
      e = Middle();
                                                 es.addElement(e);
    }
    if (es.size()==1) {if (true) return (Model.State)es.elementAt(0);}
    {if (true) return MakePar(es);}
    throw new Error("Missing return statement in function");
  }

  static final public Model.State All() throws ParseException {
  Model.State e;
    e = Loose();
    jj_consume_token(0);
                   {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

  static final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  static final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  static final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  static final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  static final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  static final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_6();
    jj_save(5, xla);
    return retval;
  }

  static final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_7();
    jj_save(6, xla);
    return retval;
  }

  static final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_8();
    jj_save(7, xla);
    return retval;
  }

  static final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_9();
    jj_save(8, xla);
    return retval;
  }

  static final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_10();
    jj_save(9, xla);
    return retval;
  }

  static final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_11();
    jj_save(10, xla);
    return retval;
  }

  static final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_12();
    jj_save(11, xla);
    return retval;
  }

  static final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_13();
    jj_save(12, xla);
    return retval;
  }

  static final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_14();
    jj_save(13, xla);
    return retval;
  }

  static final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_15();
    jj_save(14, xla);
    return retval;
  }

  static final private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_16();
    jj_save(15, xla);
    return retval;
  }

  static final private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_17();
    jj_save(16, xla);
    return retval;
  }

  static final private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_18();
    jj_save(17, xla);
    return retval;
  }

  static final private boolean jj_3R_21() {
    if (jj_scan_token(NIL0)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_11() {
    if (jj_scan_token(15)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_7()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(19)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_20() {
    if (jj_scan_token(NIL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_12() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_20()) {
    jj_scanpos = xsp;
    if (jj_3R_21()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_10() {
    if (jj_scan_token(15)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_7()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(17)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_9() {
    if (jj_scan_token(15)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_7()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(21)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_22() {
    if (jj_3R_9()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_19() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_22()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  static final private boolean jj_3R_11() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_2()) {
    jj_scanpos = xsp;
    if (jj_3R_19()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_2() {
    if (jj_3R_9()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    if (jj_3R_10()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_10()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  static final private boolean jj_3R_10() {
    if (jj_scan_token(14)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_18() {
    if (jj_scan_token(FALSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_17() {
    if (jj_scan_token(TRUE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_16() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_15() {
    if (jj_scan_token(INTEGER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_14() {
    if (jj_scan_token(NIL0)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_13() {
    if (jj_scan_token(ID)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_9() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_13()) {
    jj_scanpos = xsp;
    if (jj_3R_14()) {
    jj_scanpos = xsp;
    if (jj_3R_15()) {
    jj_scanpos = xsp;
    if (jj_3R_16()) {
    jj_scanpos = xsp;
    if (jj_3R_17()) {
    jj_scanpos = xsp;
    if (jj_3R_18()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_8() {
    if (jj_scan_token(14)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_1() {
    if (jj_3R_7()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_8()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  static final private boolean jj_3R_7() {
    if (jj_scan_token(ID)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_8() {
    if (jj_3R_7()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(22)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_7() {
    if (jj_3R_7()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(21)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_6() {
    if (jj_3R_7()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(20)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(16)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_18() {
    if (jj_3R_9()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(23)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_5() {
    if (jj_3R_7()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(19)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_4() {
    if (jj_3R_7()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(17)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_17() {
    if (jj_scan_token(15)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_3() {
    if (jj_3R_7()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(15)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_16() {
    if (jj_scan_token(15)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_12()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_15() {
    if (jj_scan_token(15)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(15)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_14() {
    if (jj_scan_token(15)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(21)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_13() {
    if (jj_scan_token(15)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_9()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(23)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_12() {
    if (jj_scan_token(15)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_7()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(15)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static private boolean jj_initialized_once = false;
  static public AutoGramTokenManager token_source;
  static SimpleCharStream jj_input_stream;
  static public Token token, jj_nt;
  static private int jj_ntk;
  static private Token jj_scanpos, jj_lastpos;
  static private int jj_la;
  static public boolean lookingAhead = false;
  static private boolean jj_semLA;
  static private int jj_gen;
  static final private int[] jj_la1 = new int[11];
  static final private int[] jj_la1_0 = {0x4000,0x2000,0x3960,0x4000,0x3960,0x180,0x400000,0x2000,0x202180,0x1000000,0x2000000,};
  static final private JJCalls[] jj_2_rtns = new JJCalls[18];
  static private boolean jj_rescan = false;
  static private int jj_gc = 0;

  public AutoGram(java.io.InputStream stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new AutoGramTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public AutoGram(java.io.Reader stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new AutoGramTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public AutoGram(AutoGramTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(AutoGramTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  static final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  static final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  static private java.util.Vector jj_expentries = new java.util.Vector();
  static private int[] jj_expentry;
  static private int jj_kind = -1;
  static private int[] jj_lasttokens = new int[100];
  static private int jj_endpos;

  static private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  static final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[26];
    for (int i = 0; i < 26; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 11; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 26; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  static final public void enable_tracing() {
  }

  static final public void disable_tracing() {
  }

  static final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 18; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  static final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}


class Value
{ public Value() {}
}

class Purename extends Value {String n; public String toString() {return n;}}
class BooleanConstant extends Value {boolean b; public String toString() {return b?"true":"false";}}
class NumericConstant extends Value {int n; public String toString() {return Integer.toString(n);}}
class StringConstant extends Value {String s; public String toString() {return "\""+s+"\"";}}

class Values extends java.util.Vector
{ public final synchronized Value valueAt(int i) {return (Value)elementAt(i);}
}

class XmitumData {boolean issend,isbound; Purename chan; Values dat;}
