/* Generated By:JavaCC: Do not edit this line. AutoGramConstants.java */
// This is a grammar, to be compiled with JavaCC.
// It translates from a text string into the pi calculus. The
// pi calculus is represented as an abstract model, solely through
// its operators (Model.Operators ops). That means that when we
// parse the text string "u<x> | u(y)" we will return the
// value ops.Par(ops.Send("u","x"), ops.Rcv("u","y")).
//
// As for the grammar itself:
//  P ::= Loose
//
//  Loose ::= Middle | Middle | ...
//    (A 'loose' is a collection of terms in parallel. It's called 'loose'
//     because parallel composition | binds least tightly.)
//
//  Middle ::= Tight + Tight + ...
//    (Summation binds a bit more tightly. So, "A+B|C" is really (A+B)|C )
//
//  Tight ::= (Loose)
//            (x..)P
//            !Tight
//            0 or Nil
//            x=y
//            Xmit
//    (Actually, here we have an issue. When you first read the ( symbol,
//     you don't know if it will start a restriction or just a parenthetical grouping.
//     We need to look ahead a little. If it is a parenthetical grouping, then
//     the Loose inside must start with (, !, 0, nil, x=, x!, x?, x< or x(.
//     So if we find ( follows by one of those, then we know it's a loose.
//     Any other ( we find must necessarily be a restriction. Yuck! 
//     NB. I disallowed vector fusions x,y,z=u,v,w from the grammar
//     because it would take an unbounded lookahead to distinguish
//     between (x,y,z)P and (x,y,z=u,v,w).
//     Another issue is that when we read 0, it might either be a
//     nil or it might be part of a fusion 0=x, so we have to lookahead
//     for the equals sign. These all feel like horrible hacks! But I'm
//     not good enough with grammars to find a better way.)
//
// Xmit ::= u!dats [.Tight]
//          u?dats [.Tight]
//          u<dats> [.Tight]
//          u(dats) [.Tight]
//          u!(dats) [.Tight]


package TextModel;

public interface AutoGramConstants {

  int EOF = 0;
  int TRUE = 5;
  int FALSE = 6;
  int NIL = 7;
  int NIL0 = 8;
  int LETTER = 9;
  int DIGIT = 10;
  int INTEGER = 11;
  int STRING = 12;
  int ID = 13;

  int DEFAULT = 0;

  String[] tokenImage = {
    "<EOF>",
    "\" \"",
    "\"\\t\"",
    "\"\\n\"",
    "\"\\r\"",
    "\"true\"",
    "\"false\"",
    "\"nil\"",
    "\"0\"",
    "<LETTER>",
    "<DIGIT>",
    "<INTEGER>",
    "<STRING>",
    "<ID>",
    "\",\"",
    "\"(\"",
    "\")\"",
    "\"<\"",
    "\">\"",
    "\"?\"",
    "\"!(\"",
    "\"!\"",
    "\".\"",
    "\"=\"",
    "\"+\"",
    "\"|\"",
  };

}
