/* Generated By:JavaCC: Do not edit this line. TokenMgrError.java Version 2.1 */
// This is a grammar, to be compiled with JavaCC.
// It translates from a text string into the pi calculus. The
// pi calculus is represented as an abstract model, solely through
// its operators (Model.Operators ops). That means that when we
// parse the text string "u<x> | u(y)" we will return the
// value ops.Par(ops.Send("u","x"), ops.Rcv("u","y")).
//
// As for the grammar itself:
//  P ::= Loose
//
//  Loose ::= Middle | Middle | ...
//    (A 'loose' is a collection of terms in parallel. It's called 'loose'
//     because parallel composition | binds least tightly.)
//
//  Middle ::= Tight + Tight + ...
//    (Summation binds a bit more tightly. So, "A+B|C" is really (A+B)|C )
//
//  Tight ::= (Loose)
//            (x..)P
//            !Tight
//            0 or Nil
//            x=y
//            Xmit
//    (Actually, here we have an issue. When you first read the ( symbol,
//     you don't know if it will start a restriction or just a parenthetical grouping.
//     We need to look ahead a little. If it is a parenthetical grouping, then
//     the Loose inside must start with (, !, 0, nil, x=, x!, x?, x< or x(.
//     So if we find ( follows by one of those, then we know it's a loose.
//     Any other ( we find must necessarily be a restriction. Yuck! 
//     Another issue is that when we read 0, it might either be a
//     nil or it might be part of a fusion 0=x, so we have to lookahead
//     for the equals sign. These all feel like horrible hacks! But I'm
//     not good enough with grammars to find a better way.)
//
// Xmit ::= u!dats [.Tight]
//          u?dats [.Tight]
//          u<dats> [.Tight]
//          u(dats) [.Tight]


package TextModel;

public class TokenMgrError extends Error
{
   /*
    * Ordinals for various reasons why an Error of this type can be thrown.
    */

   /**
    * Lexical error occured.
    */
   static final int LEXICAL_ERROR = 0;

   /**
    * An attempt wass made to create a second instance of a static token manager.
    */
   static final int STATIC_LEXER_ERROR = 1;

   /**
    * Tried to change to an invalid lexical state.
    */
   static final int INVALID_LEXICAL_STATE = 2;

   /**
    * Detected (and bailed out of) an infinite loop in the token manager.
    */
   static final int LOOP_DETECTED = 3;

   /**
    * Indicates the reason why the exception is thrown. It will have
    * one of the above 4 values.
    */
   int errorCode;

   /**
    * Replaces unprintable characters by their espaced (or unicode escaped)
    * equivalents in the given string
    */
   protected static final String addEscapes(String str) {
      StringBuffer retval = new StringBuffer();
      char ch;
      for (int i = 0; i < str.length(); i++) {
        switch (str.charAt(i))
        {
           case 0 :
              continue;
           case '\b':
              retval.append("\\b");
              continue;
           case '\t':
              retval.append("\\t");
              continue;
           case '\n':
              retval.append("\\n");
              continue;
           case '\f':
              retval.append("\\f");
              continue;
           case '\r':
              retval.append("\\r");
              continue;
           case '\"':
              retval.append("\\\"");
              continue;
           case '\'':
              retval.append("\\\'");
              continue;
           case '\\':
              retval.append("\\\\");
              continue;
           default:
              if ((ch = str.charAt(i)) < 0x20 || ch > 0x7e) {
                 String s = "0000" + Integer.toString(ch, 16);
                 retval.append("\\u" + s.substring(s.length() - 4, s.length()));
              } else {
                 retval.append(ch);
              }
              continue;
        }
      }
      return retval.toString();
   }

   /**
    * Returns a detailed message for the Error when it is thrown by the
    * token manager to indicate a lexical error.
    * Parameters : 
    *    EOFSeen     : indicates if EOF caused the lexicl error
    *    curLexState : lexical state in which this error occured
    *    errorLine   : line number when the error occured
    *    errorColumn : column number when the error occured
    *    errorAfter  : prefix that was seen before this error occured
    *    curchar     : the offending character
    * Note: You can customize the lexical error message by modifying this method.
    */
   private static final String LexicalError(boolean EOFSeen, int lexState, int errorLine, int errorColumn, String errorAfter, char curChar) {
      return("Lexical error at line " +
           errorLine + ", column " +
           errorColumn + ".  Encountered: " +
           (EOFSeen ? "<EOF> " : ("\"" + addEscapes(String.valueOf(curChar)) + "\"") + " (" + (int)curChar + "), ") +
           "after : \"" + addEscapes(errorAfter) + "\"");
   }

   /**
    * You can also modify the body of this method to customize your error messages.
    * For example, cases like LOOP_DETECTED and INVALID_LEXICAL_STATE are not
    * of end-users concern, so you can return something like : 
    *
    *     "Internal Error : Please file a bug report .... "
    *
    * from this method for such cases in the release version of your parser.
    */
   public String getMessage() {
      return super.getMessage();
   }

   /*
    * Constructors of various flavors follow.
    */

   public TokenMgrError() {
   }

   public TokenMgrError(String message, int reason) {
      super(message);
      errorCode = reason;
   }

   public TokenMgrError(boolean EOFSeen, int lexState, int errorLine, int errorColumn, String errorAfter, char curChar, int reason) {
      this(LexicalError(EOFSeen, lexState, errorLine, errorColumn, errorAfter, curChar), reason);
   }
}
